<?php
namespace plugins\antispam\library;

use \IoC;
/**
 * SimpleCaptcha class
 * @author Jérôme Brilland
 * @version 1.0
 * @copyright (c) 2023, Jérôme Brilland
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License
 */
class SimpleCaptcha {
    
    /**
     * @return
     * @access public
     */
    public function generateQuestion() {
        $i18n = IoC::resolve( 'i18n' );
        $operation = mt_rand( 0, 2 );
        switch( $operation ) {
        //addition    
        case 0 : 
            $a = mt_rand( 0, 50 );
            $b = mt_rand( 0, 50 );
            $_SESSION['antispam_answer'] = $a + $b;
            $question = $i18n->__( 'antispam_question', $a, '+', $b );
            break;
        //subtraction    
        case 1 :
            $a = mt_rand( 0 , 50 );
            do {
                $b = mt_rand( 0, 50 );
            }
            while ( $b > $a );
            $_SESSION['antispam_answer'] = $a - $b;
            $question = $i18n->__( 'antispam_question', $a, '-', $b );
            break;
        //multiplication
        case 2 :
            $a = mt_rand( 0, 10 );
            $b = mt_rand( 0, 10 );
            $_SESSION['antispam_answer'] = $a * $b;
            $question = $i18n->__( 'antispam_question', $a, 'x', $b );
        }
        return $question;
    } 
    
    /**
     * @param int answer Answer
     * @return boolean
     * @access public
     */
     public function checkAnswer( $answer ) {
         if ( !isset( $_SESSION['antispam_answer'] ) ) {
             return false;
         }
         if ( $_SESSION['antispam_answer'] <> trim( $answer ) ) {
             return false;
         }
         unset( $_SESSION['antispam_answer'] );
         return true;
     } 
    
}

